using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using System.Data.SqlClient;
using System.Transactions;
using System.Threading;
using System.Reflection;
using System.Data;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_Camareros_Datos : ABS_Datos
    {
        #region Listados
        private List<INTERNO_HPV_Camareros_Listado_Modelo> g_lst_INTERNO_HPV_Camareros_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_HPV = null;
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Camareros).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................
                if ((g_lst_INTERNO_HPV_Camareros_Listado_Modelo != null) && (g_lst_INTERNO_HPV_Camareros_Listado_Modelo.Count() > 0))
                {
                    lst_HPV = g_lst_INTERNO_HPV_Camareros_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_HPV;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Camareros).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_Camareros_Listado_Modelo != null) && (g_lst_INTERNO_HPV_Camareros_Listado_Modelo.Count() > 0))
                {
                    dnm_HPV = g_lst_INTERNO_HPV_Camareros_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.id) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.id) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.codigo) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.codigo) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.nombre) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.nombre) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.fechaAlta) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaAlta) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.fechaBaja) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaBaja) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.validacion_Nombre) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.validacion_Nombre) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.validacion_Nombre) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.validacion_Nombre) + "," +
                          //ids
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.idEmpleado) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpleado) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.idProveedor) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idProveedor) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.idEmpresa) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + "," +
                          nameof(INTERNO_HPV_Camareros_Listado_Modelo.idCamareroPerfil) + " = " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idCamareroPerfil) + "," +
                          //Empleado
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado)))
                                ?
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado_Codigo) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.codigo) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado_Descripcion) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.nombre) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado_FechaBorrado) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.fechaBorrado) + ","
                                    )
                                :
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado_Codigo) + " = ''," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado_Descripcion) + " = ''," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado_FechaBorrado) + " = NULL ,"
                                    )
                          ) +
                          //Proveedor
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor)))
                                ?
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor_Codigo) + " = " + nameof(MAE_Proveedores) + "." + nameof(MAE_Proveedores.codigo) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor_Descripcion) + " = " + nameof(MAE_Proveedores) + "." + nameof(MAE_Proveedores.razonSocial) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor_FechaBorrado) + " = " + nameof(MAE_Proveedores) + "." + nameof(MAE_Proveedores.fechaBorrado) + ","
                                    )
                                :
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor_Codigo) + " = ''," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor_Descripcion) + " = ''," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor_FechaBorrado) + " = NULL,"
                                    )
                          ) +
                          //Empresa
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa)))
                                ?
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) + ","
                                    )
                                :
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa_Descripcion) + "= '', " +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa_FechaBorrado) + " = NULL ,"
                                    )
                          ) +
                          //CamareroPerfil
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil)))
                                ?
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil_Codigo) + " = " + nameof(HPV_CamarerosPerfiles) + "." + nameof(HPV_CamarerosPerfiles.codigo) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil_Descripcion) + " = " + nameof(HPV_CamarerosPerfiles) + "." + nameof(HPV_CamarerosPerfiles.descripcion) + "," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil_FechaBorrado) + " = " + nameof(HPV_CamarerosPerfiles) + "." + nameof(HPV_CamarerosPerfiles.fechaBorrado)
                                    )
                                :
                                    (
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil_Codigo) + " = ''," +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil_Descripcion) + "= '', " +
                                        nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil_FechaBorrado) + " = NULL "
                                    )
                          ) +
                          " FROM " + nameof(HPV_Camareros) +
                          //Empleado
                          (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empleado)))
                                ?
                                    (
                                         " LEFT JOIN " + nameof(MAE_Empleados) + " ON " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpleado) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.id)
                                    )
                                : ("")
                          ) +
                          //Proveedor
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.Proveedor)))
                                ?
                                    (
                                          " LEFT JOIN " + nameof(MAE_Proveedores) + " ON " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idProveedor) + " = " + nameof(MAE_Proveedores) + "." + nameof(MAE_Proveedores.id)
                                    )
                                : ("")
                          ) +
                          //Empresa
                          (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.Empresa)))
                                ?
                                    (
                                         " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                    )
                                : ("")
                          ) +
                          //CamareroPerfil
                          (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_HPV_Camareros_Listado_Modelo.CamareroPerfil)))
                                ?
                                    (
                                         " LEFT JOIN " + nameof(HPV_CamarerosPerfiles) + " ON " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idCamareroPerfil) + " = " + nameof(HPV_CamarerosPerfiles) + "." + nameof(HPV_CamarerosPerfiles.id)
                                    )
                                : ("")
                          ) +
                          " WHERE " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaBorrado) + " IS null AND " +
                              " ( " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + "=@idEmpresa " +
                                  (
                                      (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0)
                                          ? (" OR " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                          : " "
                                  ) +
                              " ) AND " +
                              (_lng_id > -1 ? nameof(HPV_Camareros) + "." + (nameof(HPV_Camareros.id) + "=@id") : "1 = 1");

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_HPV_Camareros_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_Camareros_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_HPV_Camareros_Listado_Modelo g_mdl_INTERNO_HPV_Camareros_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Camareros).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_Camareros_Listado_Modelo_F3 != null)
                {
                    dnm_HPV = g_mdl_INTERNO_HPV_Camareros_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_HPV = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_Camareros).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_Camareros_Listado_Modelo_F3 != null)
                {
                    dnm_HPV = g_mdl_INTERNO_HPV_Camareros_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_HPV;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                string str_SQL =
                   " SELECT distinct " +
                       nameof(INTERNO_HPV_Camareros_Listado_Modelo.id) + " = " + nameof(HPV_Camareros.id) + "," +
                       nameof(INTERNO_HPV_Camareros_Listado_Modelo.codigo) + " = " + nameof(HPV_Camareros.codigo) + "," +
                       nameof(INTERNO_HPV_Camareros_Listado_Modelo.nombre) + " = " + nameof(HPV_Camareros.nombre) +
                   " FROM " + nameof(HPV_Camareros) +
                   " WHERE " + nameof(HPV_Camareros.fechaBorrado) + " IS null AND " +
                         " ( " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + "=@idEmpresa " +
                              (
                                  (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                      ? (" OR " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                      : " "
                              ) +
                          " ) AND " +
                        (
                         (_lng_id > -1)
                           ? (nameof(HPV_Camareros.id) + " = " + _lng_id)
                           : (
                                //Filtrar por Codigo
                                (_str_CampoBusqueda.Equals(nameof(HPV_Camareros.codigo)))
                                    ? (nameof(HPV_Camareros.codigo) + "=@Filtro")
                                    //Filtrar por Nombre
                                    : (nameof(HPV_Camareros.nombre) + "=@Filtro")
                             )
                        );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_HPV_Camareros_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_Camareros_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 4;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                string str_SQL =
                          " SELECT " +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.id) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpleado) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idProveedor) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.codigo) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.nombre) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaAlta) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaBaja) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.validacion_Nombre) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.validacion_Clave) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idEmpresa) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaBorrado) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.foto) + "," +
                              nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.idCamareroPerfil) +
                        " FROM " + nameof(HPV_Camareros) +
                        " WHERE  " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.fechaBorrado) + " IS null AND " +
                                     nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<HPV_Camareros>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Empleados ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADO = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                        Thread obj_Thread_MAYOR_EMPLEADO = new Thread(obj_ThreadStart_EMPLEADO);
                        obj_Thread_MAYOR_EMPLEADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_Proveedores ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idProveedor != null)
                    {
                        ThreadStart obj_ThreadStart_PROVEEDOR = new ThreadStart(Obtener_Proveedor_Modelo_Obtener);
                        Thread obj_Thread_MAYOR_PROVEEDOR = new Thread(obj_ThreadStart_PROVEEDOR);
                        obj_Thread_MAYOR_PROVEEDOR.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //GEN_Empresas ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpresa != null)
                    {
                        ThreadStart obj_ThreadStart_EMPRESA = new ThreadStart(Obtener_Empresa_Modelo_Obtener);
                        Thread obj_Thread_MAYOR_EMPRESA = new Thread(obj_ThreadStart_EMPRESA);
                        obj_Thread_MAYOR_EMPRESA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[2] = true;
                    }

                    //HPV_CamarerosPerfiles ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idCamareroPerfil != null)
                    {
                        ThreadStart obj_ThreadStart_CAMAREROSPERFILES = new ThreadStart(Obtener_CamarerosPerfiles_Modelo_Obtener);
                        Thread obj_Thread_MAYOR_CAMAREROSPERFILES = new Thread(obj_ThreadStart_CAMAREROSPERFILES);
                        obj_Thread_MAYOR_CAMAREROSPERFILES.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[3] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch(Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_Proveedor_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEPROVEEDORES_OBTENERMODELO_POR_ID_AUX1, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idProveedor,true,true, true, true,true,true,true };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Proveedores = (MAE_Proveedores)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_Empresa_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_Empresas = Datos_Generales.GEN_Empresas_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idEmpresa);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        private void Obtener_CamarerosPerfiles_Modelo_Obtener()
        {
            try
            {
                HPV_CamarerosPerfiles_Datos obj_HPV_CamarerosPerfiles_Datos = new HPV_CamarerosPerfiles_Datos();
                g_dnm_Modelo_Obtener.HPV_CamarerosPerfiles = obj_HPV_CamarerosPerfiles_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idCamareroPerfil);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[3] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private HPV_Camareros g_mdl_HPV_Camareros = null;

        public HPV_Camareros Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(HPV_Camareros) + "." + nameof(HPV_Camareros.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HPV_Camareros;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_HPV_Camareros = obj_Exferia_Entities.Database.SqlQuery<HPV_Camareros>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(HPV_Camareros.id) + "," +
                    nameof(HPV_Camareros.idEmpleado) + "," +
                    nameof(HPV_Camareros.idProveedor) + "," +
                    nameof(HPV_Camareros.codigo) + "," +
                    nameof(HPV_Camareros.nombre) + "," +
                    nameof(HPV_Camareros.fechaAlta) + "," +
                    nameof(HPV_Camareros.fechaBaja) + "," +
                    nameof(HPV_Camareros.validacion_Nombre) + "," +
                    nameof(HPV_Camareros.validacion_Clave) + "," +
                    nameof(HPV_Camareros.idEmpresa) + "," +
                    nameof(HPV_Camareros.fechaBorrado) + "," +
                    nameof(HPV_Camareros.foto) + "," +
                    nameof(HPV_Camareros.idCamareroPerfil) +
                " FROM " + nameof(HPV_Camareros);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                HPV_Camareros mdl_HPV_Camareros_AGrabar = (HPV_Camareros)_mdl_obj;
                HPV_Camareros mdl_HPV_Camareros_DatosViejos = new HPV_Camareros();

                // Ver si existe ######################################################################
                HPV_Camareros mdl_HPV_Camareros_Final = Obtener_Modelo_Por_Id(mdl_HPV_Camareros_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_HPV_Camareros_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_Camareros_Final, mdl_HPV_Camareros_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_Camareros_AGrabar, mdl_HPV_Camareros_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(HPV_Camareros) +
                                           " SET " +
                                               nameof(HPV_Camareros.idEmpleado) + "=@idEmpleado," +
                                               nameof(HPV_Camareros.idProveedor) + "=@idProveedor," +
                                               nameof(HPV_Camareros.codigo) + "=@codigo," +
                                               nameof(HPV_Camareros.nombre) + "=@nombre," +
                                               nameof(HPV_Camareros.fechaAlta) + "=@fechaAlta," +
                                               nameof(HPV_Camareros.fechaBaja) + "=@fechaBaja," +
                                               nameof(HPV_Camareros.validacion_Nombre) + "=@validacion_Nombre," +
                                               nameof(HPV_Camareros.validacion_Clave) + "=@validacion_Clave," +
                                               nameof(HPV_Camareros.idEmpresa) + "=@idEmpresa," +
                                               nameof(HPV_Camareros.fechaBorrado) + "=@fechaBorrado," +
                                               nameof(HPV_Camareros.foto) + "=@foto," +
                                               nameof(HPV_Camareros.idCamareroPerfil) + "=@idCamareroPerfil" +
                                           " WHERE " +
                                               nameof(HPV_Camareros.id) + "=@id";

                    //Parametros
                    SqlParameter obj_SqlParameter_imagen = new SqlParameter("@foto", SqlDbType.Binary);
                    if (mdl_HPV_Camareros_Final.foto != null)
                    { obj_SqlParameter_imagen.Value = mdl_HPV_Camareros_Final.foto; }
                    else
                    { obj_SqlParameter_imagen.Value = DBNull.Value; }

                    object[] arr_Parametros_Update = new object[]
                    {
                        mdl_HPV_Camareros_Final.idEmpleado != null
                            ?   new SqlParameter("@idEmpleado", mdl_HPV_Camareros_Final.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        mdl_HPV_Camareros_Final.idProveedor != null
                            ?   new SqlParameter("@idProveedor", mdl_HPV_Camareros_Final.idProveedor.Value)
                            :   new SqlParameter("@idProveedor",  DBNull.Value),
                        new SqlParameter("@codigo",  mdl_HPV_Camareros_Final.codigo),
                        new SqlParameter("@nombre",  mdl_HPV_Camareros_Final.nombre),
                        new SqlParameter("@fechaAlta",  mdl_HPV_Camareros_Final.fechaAlta),
                        mdl_HPV_Camareros_Final.fechaBaja != null
                            ?   new SqlParameter("@fechaBaja", mdl_HPV_Camareros_Final.fechaBaja.Value)
                            :   new SqlParameter("@fechaBaja",  DBNull.Value),
                        mdl_HPV_Camareros_Final.validacion_Nombre != null
                            ?   new SqlParameter("@validacion_Nombre", mdl_HPV_Camareros_Final.validacion_Nombre)
                            :   new SqlParameter("@validacion_Nombre",  DBNull.Value),
                        mdl_HPV_Camareros_Final.validacion_Clave != null
                            ?   new SqlParameter("@validacion_Clave", mdl_HPV_Camareros_Final.validacion_Clave)
                            :   new SqlParameter("@validacion_Clave",  DBNull.Value),
                        new SqlParameter("@idEmpresa",  mdl_HPV_Camareros_Final.idEmpresa),
                        mdl_HPV_Camareros_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_Camareros_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        obj_SqlParameter_imagen,
                         mdl_HPV_Camareros_Final.idCamareroPerfil!=null
                            ?   new SqlParameter("@idCamareroPerfil", mdl_HPV_Camareros_Final.idCamareroPerfil.Value)
                            :   new SqlParameter("@idCamareroPerfil",  DBNull.Value),
                         new SqlParameter("@id",  mdl_HPV_Camareros_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_HPV_Camareros_Final.id;
                }
                //INSERT
                else
                {
                    mdl_HPV_Camareros_Final = new HPV_Camareros();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_Camareros_AGrabar, mdl_HPV_Camareros_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HPV_Camareros) +
                                              " (" +
                                                      nameof(HPV_Camareros.idEmpleado) + "," +
                                                      nameof(HPV_Camareros.idProveedor) + "," +
                                                      nameof(HPV_Camareros.codigo) + "," +
                                                      nameof(HPV_Camareros.nombre) + "," +
                                                      nameof(HPV_Camareros.fechaAlta) + "," +
                                                      nameof(HPV_Camareros.fechaBaja) + "," +
                                                      nameof(HPV_Camareros.validacion_Nombre) + "," +
                                                      nameof(HPV_Camareros.validacion_Clave) + "," +
                                                      nameof(HPV_Camareros.idEmpresa) + "," +
                                                      nameof(HPV_Camareros.fechaBorrado) + "," +
                                                      nameof(HPV_Camareros.foto) + "," +
                                                      nameof(HPV_Camareros.idCamareroPerfil) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(HPV_Camareros.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@idEmpleado," +
                                                  "@idProveedor," +
                                                  "@codigo," +
                                                  "@nombre," +
                                                  "@fechaAlta," +
                                                  "@fechaBaja," +
                                                  "@validacion_Nombre," +
                                                  "@validacion_Clave," +
                                                  "@idEmpresa," +
                                                  "@fechaBorrado," +
                                                  "@foto," +
                                                  "@idCamareroPerfil" +
                                              " ) ";

                    //Parametros
                    SqlParameter obj_SqlParameter_imagen = new SqlParameter("@foto", SqlDbType.Binary);
                    if (mdl_HPV_Camareros_Final.foto != null)
                    { obj_SqlParameter_imagen.Value = mdl_HPV_Camareros_Final.foto; }
                    else
                    { obj_SqlParameter_imagen.Value = DBNull.Value; }

                    object[] arr_Parametros_Insert = new object[]
                    {
                        mdl_HPV_Camareros_Final.idEmpleado != null
                            ?   new SqlParameter("@idEmpleado", mdl_HPV_Camareros_Final.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        mdl_HPV_Camareros_Final.idProveedor != null
                            ?   new SqlParameter("@idProveedor", mdl_HPV_Camareros_Final.idProveedor.Value)
                            :   new SqlParameter("@idProveedor",  DBNull.Value),
                        new SqlParameter("@codigo",  mdl_HPV_Camareros_Final.codigo),
                        new SqlParameter("@nombre",  mdl_HPV_Camareros_Final.nombre),
                        new SqlParameter("@fechaAlta",  mdl_HPV_Camareros_Final.fechaAlta),
                        mdl_HPV_Camareros_Final.fechaBaja != null
                            ?   new SqlParameter("@fechaBaja", mdl_HPV_Camareros_Final.fechaBaja.Value)
                            :   new SqlParameter("@fechaBaja",  DBNull.Value),
                        mdl_HPV_Camareros_Final.validacion_Nombre != null
                            ?   new SqlParameter("@validacion_Nombre", mdl_HPV_Camareros_Final.validacion_Nombre)
                            :   new SqlParameter("@validacion_Nombre",  DBNull.Value),
                        mdl_HPV_Camareros_Final.validacion_Clave != null
                            ?   new SqlParameter("@validacion_Clave", mdl_HPV_Camareros_Final.validacion_Clave)
                            :   new SqlParameter("@validacion_Clave",  DBNull.Value),
                        new SqlParameter("@idEmpresa",  mdl_HPV_Camareros_Final.idEmpresa),
                        mdl_HPV_Camareros_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_Camareros_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        obj_SqlParameter_imagen,
                         mdl_HPV_Camareros_Final.idCamareroPerfil!=null
                            ?   new SqlParameter("@idCamareroPerfil", mdl_HPV_Camareros_Final.idCamareroPerfil.Value)
                            :   new SqlParameter("@idCamareroPerfil",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_Camareros), mdl_HPV_Camareros_DatosViejos, mdl_HPV_Camareros_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);

                // Devolver también el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Objeto = mdl_HPV_Camareros_Final;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HPV_Camareros mdl_HPV_Camareros_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_HPV_Camareros_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(HPV_Camareros) +
                                                " SET " +
                                                nameof(HPV_Camareros.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(HPV_Camareros.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_Camareros), null, mdl_HPV_Camareros_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Camareros_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
